local module = {}

function module.create(spritesheet, timer)
    local animation = {
        spritesheet = spritesheet,
        current = 1,
        timer = timer
    }

    function animation:update(dt)
        if self.timer:update(dt) then
            return self:increment()
        end
        return false
    end

    function animation:increment() 
        self.current = self.current + 1
        if self.current > #spritesheet.quads then
            self.current = 1
            return true
        else return false end
    end

    function animation:reset() --[ update must be called after a reset ]
        self.timer:reset()
        self.current = 1
    end

    function animation:draw(x, y, sx, sy)
        self.spritesheet:draw(self.current, x, y, sx, sy)
    end

    return animation
end

return module
