local module = {} 

function module.create(scaleX, scaleY, posX, posY, rotation)
    local camera = {
        scaleX = scaleX or 1,
        scaleY = scaleY or 1,
        posX = posX or 0,
        posY = posY or 0,
        rotation = rotation or 0
    }

    function camera:set()
        love.graphics.push()
        love.graphics.rotate(-self.rotation)
        love.graphics.scale(1 / camera.scaleX, 1 / camera.scaleY)
        love.graphics.translate(-camera.posX, -camera.posY)
    end

    function camera:unset()
        love.graphics.pop()
    end

    function camera:rotate(radians)
        self.rotation = self.rotation + radians
    end

    function camera:move(x, y)
        self.posX = self.posX + (x * 10)
        self.posY = self.posY + (y * 10)
    end

    function camera:zoom(scaleX, scaleY)
        scaleY = scaleY or scaleX
        self.scaleX = self.scaleX + scaleX
        self.scaleY = self.scaleY + scaleY
    end

    return camera
end

return module